<template>
  <!--collapse 是否水平折叠收起菜单-->
  <el-menu
    :collapse="isCollapse"
    :default-active="$route.path"
    class="el-menu-vertical-demo"
    background-color="#545c64"
    text-color="#fff"
    active-text-color="#fff"
  >
    <el-menu-item :index="menu.path" v-for="item in noChildren" :key="item.path" @click="clickMenu(item)">
      <i :class="'el-icon-' + item.icon" style="color:#fff"></i>
      <span slot="title">{{ item.label }}</span>
    </el-menu-item>
    <el-submenu :index="item.label" v-for="(item, index) in hasChildren" :key="index">
      <template slot="title">
        <i :class="'el-icon-' + item.icon" style="color:#fff"></i>
        <span slot="title">{{ item.label }}</span>
      </template>
      <el-menu-item-group>
        <el-menu-item :index="subItem.path" v-for="(subItem, subIndex) in item.children" :key="subIndex" @click="clickMenu(subItem)">
          <i :class="'el-icon-' + subItem.icon" style="color:#fff"></i>
          <span slot="title">{{ subItem.label }}</span>
        </el-menu-item>
      </el-menu-item-group>
    </el-submenu>
  </el-menu>
</template>

<script>
export default {
  // 计算属性
  computed: {
    // 没有子菜单
    noChildren () {
      return this.menu.filter(item => !item.children)
    },
    // 有子菜单 (这样设置会有一个问题 就是有子菜单的 永远会在没有子菜单的下面
    hasChildren () {
      return this.menu.filter(item => item.children)
    },
    isCollapse () {
      // 这里的数据就是从vuex取得
      return this.$store.state.tab.isCollapse
    }
  },
  data () {
    return {
      menu: [
        {
          path: '/',
          name: 'home',
          label: '首页',
          icon: 's-home'
        }, {
          path: '/browsefood',
          name: 'browsefood',
          label: '餐饮',
          icon: 'food'
        }, {
          path: '/browseworkout',
          name: 'browseworkout',
          label: '运动',
          icon: 'basketball'
        }, {
          label: '订单',
          icon: 'notebook-2',
          children: [
            {
              path: '/UserFoodOrderManage',
              name: 'UserFoodOrderManage',
              label: '餐品订单',
              icon: 'burger'
            },
            {
              path: '/UseSportOrderManage',
              name: 'UseSportOrderManage',
              label: '服务订单',
              icon: 'soccer'
            }
          ]
        }, {
          path: '/showviewinfo',
          name: 'showviewinfo',
          label: '设置',
          icon: 'setting'
        }
      ]
    }
  },
  methods: {
    // 跳转路由 根据名称跳转
    clickMenu (item) {
      this.$router.push(item.path)
    }
  }
}
</script>

<style scoped>
.el-menu {
  height: 100%;
  border: none;
}
.el-menu-vertical-demo:not(.el-menu--collapse) {
  width: 200px;
  min-height: 400px;
}
</style>
